;;=============================================================================
;;
;;     ,   AT  PS/2 -  
;;
;;==========================================================================
;; ,  AT  PS/2-
;;
;; http://www.computer-engineering.org/ps2protocol/
;;
;;  : - "0", 8  ,  ޣ  - "1" ( 11 ݣ).
;;        Clock      
;;   .    - ӣ .
;;      -  30-50 mks ( 10-16 ).
;;
;;    - ,  ݣ  Clock (11 )   Data.
;;   ,    50 mks  Clock  .
;;
;;    ,   Clock  "0".    
;;     ̣ .    >100 mks    ,
;;  ԣ            
;; (    ,     ).    ģ
;;   ,      .
;;
;;    - ,   Clock   ,
;; ,  100mks, Data      Clock.
;;   ģ  Clock 1-0,      Data  ģ  Clock  0-1.
;; Clock  .  11 :  8  ,  ޣ,
;; - "1" ( )   ,     0,
;;  ţ ӣ .   ,     .
;;     -,     Clock.
;;
;;   +  ޣ    (xor  add) ޣ .
;;  ޣ = 1,    ޣ.
;;

;        :
; +   (,  ...)
; +    PS/2
; --    PS/2,
; --     ,         
;      (      )
;        r24/r25    (0x00  0xE0) /  +  /   T
; --  +       
; +    PS/2
; --    PS/2
; --     PS/2         (    )
; +    
;      


.equ	pkb_DataDDR	= DDRD
.equ	pkb_DataPortO	= PORTD
.equ	pkb_DataPortI	= PIND
.equ	pkb_DataPin	= 0

.equ	pkb_ClockDDR	= DDRD
.equ	pkb_ClockPortO	= PORTD
.equ	pkb_ClockPortI	= PIND
.equ	pkb_ClockPin	= 2

;   

.equ	pkb_CapsLed	= 4
.equ	pkb_NumLed	= 2
.equ	pkb_ScroolLed	= 1


.cseg

;
; 
;
pkb_Init:

;         ( )
;    ,      ,     ATmeg
;     
 rcall	pkg_LockClock			;    ,      
 ldi	r16, 0xFF
 rcall	pkb_SendByte			;   Reset (   )

pkb_I_loop2:
 ldi	r19, 80				; -    
pkb_I_loop:
 rcall	pkb_RecvByte
 brcc	pkb_I_loc0
 dec	r19
 brne	pkb_I_loop

 ldi	r16, ec_pkb_NoInitAnswer	;        
 rjmp	Wait_MsgError

pkb_I_loc0:
 cpi	r16, 0xFA			;   , ģ 
 breq	pkb_I_loop2
 cpi	r16, 0xAA			;      
 breq	pkg_I_fin0

 ldi	r16, ec_pkb_FaultInitAnswer	;   
 rjmp	Wait_MsgError
 
pkg_I_fin0:
 rcall	pkb_RecvByte			;   ,     0x00
 brcs	pkg_I_fin_Keyboard
 tst	r16
 brne	pkg_I_fin_Keyboard

 ldi	r16, 0xF4			;       
 rcall	pkb_SendByte
 brcc	pkg_I_fin_Mouse			;    - 
 ldi	r16, ac_pkb_InvMouseInit
 rcall	Wait_MsgError
pkg_I_fin_Mouse:
 ldi	r16, 1<<main_FRAM_MouseMode	;   
 or	main_rFlagsRAM, r16

 ldi	r16, 0xE8			;   
 rcall	pkb_SendByte
 rcall	pkb_RecvByte
 ldi	r16, 0x00			; 1 ޣ  1   (  4/1)
 rcall	pkb_SendByte
 rjmp	pkb_RecvByte

pkg_I_fin_Keyboard:
 ldi	r16, 0xFF-(1<<main_FRAM_MouseMode)
 and	main_rFlagsRAM, r16		;    
 ret

;
;    ,    ...   
;
pkg_LockClock:
 cbi	pkb_DataDDR, pkb_DataPin	; Data   ̣
 sbi	pkb_DataPortO, pkb_DataPin

 cbi	pkb_ClockPortO, pkb_ClockPin	; Clock  
 sbi	pkb_ClockDDR, pkb_ClockPin
 ret

;
;     
;  C = 1     C = 0
;         (E0xx  00xx)  r24/r25
;     T = 1     T = 0  
;
;      :
; 0xAA -   
; 0xFC -   
; 0xEE -   
; 0xFA -   
; 0xFE -     ( ,    ,   + 
;	      0xFA,       ޣ)
; 0x00 -   (   0xFF,     0x00)
;
;    (      - )  :
; 0xE1       -  Pause,      (E1) 14 77 E1 F0 14 F0 77
;	      ( E1 14 + 77 )   ( E1 F0 14 + F0 77 )
; 0xE0, 0x12 -  Print,  ,  
; 0xE0, 0x7C -  Print,  ,   ,     
; 	  Print    E0F07C,  E0F012
; 0xE0, 0xF0 -  - ,    
; 0xF0,      -  - ,    
; 0xE0, xxxx -  ,  ,   
; xxxx       -  ,  ,   
;
pkb_RecvCode:
 rcall	pkb_RecvByte
 brcs	pkb_RC_fin

;   E1  E0,    Pause    Ctrl + Num
;        

 cpi	r16, 0xE1
 brne	pkb_RC_loc0
 ldi	r16, 0xE0
pkb_RC_loc0:

;    E0,      r25    
;   E0,  r25 = 0 

 clr	r25
 cpi	r16, 0xE0
 brne	pkb_RC_loc1
 mov	r25, r16
 rcall	pkb_RecvByte
 brcs	pkb_RC_fin
pkb_RC_loc1:

;     r25   ,       
;    ,   T = 1    ,  T = 0       

 clt
 cpi	r16, 0xF0
 brne	pkb_RC_loc2
 set
 rcall	pkb_RecvByte
 brcs	pkb_RC_fin
pkb_RC_loc2:

;   r16   ,     r24

 mov	r24, r16
 clc

pkb_RC_fin:
 ret

;
;  pkb_RecvCode,        ,  Echo
;  C = 1            Echo    ţ 
;  C = 0      -
;
pkb_RecvCode_WithCtrl:
 rcall	pkb_RecvCode
 brcc	pkb_RC_fin

; ,        .  ,     
;   ,        ""

 ldi	r16, 0xEE		;  Echo
 rcall	pkb_SendByte
 brcs	pkb_RCWC_UnableSend

 rcall	pkb_RecvByte
 brcs	pkb_RCWC_UnableRecv
 cpi	r16, 0xEE
 sec
 breq	pkb_RC_fin		;    Echo

;   Echo

 ldi	r16, ac_pkb_InvalidEcho
 rjmp	pkb_RCWC_ReInit

;    

pkb_RCWC_UnableRecv:
 ldi	r16, ac_pkb_UnableRecvEcho
 rjmp	pkb_RCWC_ReInit

;     Echo

pkb_RCWC_UnableSend:
 ldi	r16, ac_pkb_UnableSendEcho

;   

pkb_RCWC_ReInit:
 rcall	Wait_MsgError
 rcall	pkb_Init
 rcall	pkb_ShowStatus
 sec
 ret

;
;     Clock
;   > 200 mks  C = 1,   Clock      
;
pkb_Wait0Clock:
 ldi	r28, 200
;
pkb_W0C_loop:
 sbis	pkb_ClockPortI, pkb_ClockPin	; 2
 ret
 dec	r28				; 1
 nop					; 1
 nop					; 1
 nop					; 1
 brne	pkb_W0C_loop			; 2
 rjmp	pkb_W1C_err
;
;
pkb_Wait1Clock:
 ldi	r28, 200
;
pkb_W1C_loop:
 sbic	pkb_ClockPortI, pkb_ClockPin	; 2
 ret
 dec	r28				; 1
 nop					; 1
 nop					; 1
 nop					; 1
 brne	pkb_W1C_loop			; 2
;
pkb_W1C_err:
 pop	r28
 pop	r28
 ldi	r16, 0x01
 sec
 rjmp	pkg_LockClock

;
;       Clock
;     20mks   Z
;    C = 1       
;
pkb_LongWait0Clock:
 sbis	pkb_ClockPortI, pkb_ClockPin
 ret
 rcall	Wait_20mks
 sbiw	Z, 1
 brne	pkb_LongWait0Clock
;
 pop	ZL
 pop	ZH
 ldi	r16, 0x02
 sec
 rjmp	pkg_LockClock

;
;   
;   r16 , C = 0  .     C = 1
; r16 -  : 0x01 -    ɣ, 0x02 -    ɣ, 0x03 -  ޣ
;
; ***************************************************************************************************
; * ,        -     .*
; *           ( ţ /ߣ)    *
; * ,  ,     ,                          *
; ***************************************************************************************************
;
pkb_RecvByte:
 cbi	pkb_DataDDR, pkb_DataPin	;   
 sbi	pkb_DataPortO, pkb_DataPin

 cbi	pkb_ClockDDR, pkb_ClockPin
 sbi	pkb_ClockPortO, pkb_ClockPin
 rcall	Wait_20mks			;     

;  -, ģ  1/40 sec
; 1250 * 20 mks = 0.025 sec (1/40 sec)

 ldi	ZL, low (1250)
 ldi	ZH, high(1250)
 rcall	pkb_LongWait0Clock

; ģ ߣ 

pkb_RB_1:
 rcall	pkb_Wait1Clock

;   

 clr	r17		; 
 ldi	r18, 8		; ޣ 
pkb_RB_loop:
 rcall	pkb_Wait0Clock
 rcall	Wait_4mks
 clc
 sbic	pkb_DataPortI, pkb_DataPin
 sec
 ror	r16
 rcall	pkb_Wait1Clock
 eor	r17, r16	;    r17.7
 dec	r18
 brne	pkb_RB_loop

;   ޣ

 rcall	pkb_Wait0Clock
 rcall	Wait_4mks
 clc
 sbic	pkb_DataPortI, pkb_DataPin
 sec
 ror	r18
 rcall	pkb_Wait1Clock
 eor	r17, r18
 brpl	pkb_RB_ParErr	;   +  ޣ   1  

;  -

 rcall	pkb_Wait0Clock
 rcall	pkb_Wait1Clock

;       

 clc
 rjmp	pkg_LockClock

;  ޣ:  ,    ,      

pkb_RB_ParErr:
 rcall	Wait_300ms
 ldi	r16, 0x03
 sec
 rjmp	pkg_LockClock

;
;   
;  r16,    C = 0,   C = 1   r16 -  :
; 0x01 -    ɣ, 0x02 -    ɣ
;
pkb_SendByte:
 rcall	Wait_40mks
 rcall	Wait_40mks
 cbi	pkb_DataPortO, pkb_DataPin	;  Clock   "0",    Data
 sbi	pkb_DataDDR, pkb_DataPin	;    
 rcall	Wait_40mks
 cbi	pkb_ClockDDR, pkb_ClockPin	;   Clock -   ģ 
 sbi	pkb_ClockPortO, pkb_ClockPin
 rcall	pkb_Wait1Clock

;  ,  Clock = 1,     10 ms    

 ldi	ZL, low (250)
 ldi	ZH, high(250)
 rcall	pkb_LongWait0Clock

;   

 clr	r17				; 
 ldi	r18, 8				; ޣ 
pkb_SB_loop:
 rcall	pkb_Wait0Clock			;     ,    
 rcall	Wait_4mks
 cbi	pkb_DataPortO, pkb_DataPin
 sbrc	r16, 0
 sbi	pkb_DataPortO, pkb_DataPin
 rcall	pkb_Wait1Clock
 eor	r17, r16
 ror	r16
 dec	r18
 brne	pkb_SB_loop

;   ޣ

 rcall	pkb_Wait0Clock
 rcall	Wait_4mks
 cbi	pkb_DataPortO, pkb_DataPin
 sbrs	r17, 0				;     
 sbi	pkb_DataPortO, pkb_DataPin
 rcall	pkb_Wait1Clock

;      -

 rcall	pkb_Wait0Clock
 cbi	pkb_DataDDR, pkb_DataPin	;  ,        Data
 sbi	pkb_DataPortO, pkb_DataPin	; ..         ţ

;  ģ   (   Data = 0)

pkb_SB_loop2:
 rcall	pkb_Wait0Clock
 rcall	Wait_4mks
 sbis	pkb_DataPortI, pkb_DataPin
 rjmp	pkb_SB_fin			;    ,    ɣ
 rcall	pkb_Wait1Clock
 rjmp	pkb_SB_loop2

; ӣ,       Data

pkb_SB_fin:
pkb_SB_loop3:
 sbis	pkb_DataPortI, pkb_DataPin
 rjmp	pkb_SB_loop3

 clc
 rjmp	pkg_LockClock

;
;    (/LAT, ...)
;  = Num Lock, LAT = Scrool Lock, - = Caps Lock
;
pkb_ShowStatus:
 ldi	r16, pkb_ScroolLed

 ldi	r29, pkb_ScroolLed | pkb_NumLed	; /LAT
 sbrs	akb_rMod, akb_Mod_RL
 eor	r16, r29
 
 sbrc	akb_rMod, akb_Mod_Set		; 
 sbr	r16, pkb_CapsLed
 
;
;   (r16 -  Caps/Num/Scrool   )
;
pkb_SetLed:
 mov	r19, r16
 ldi	r16, 0xED

pkb_Set:
 sbrc	main_rFlagsRAM, main_FRAM_MouseMode
 ret			;        ,    

 rcall	pkb_SendByte
 rcall	pkb_RecvByte	;   0xFA,   

 mov	r16, r19
 rcall	pkb_SendByte
 rjmp	pkb_RecvByte	;   0xFA,   

;
;   
;
pkb_SetFast:		;  30 /,    "PC-"
 ldi	r16, 0xF3
 ldi	r19, 0x00
 rjmp	pkb_Set

pkb_SetSlow:		;  2 /,    "-"
 ldi	r16, 0xF3	; (       )
 ldi	r19, 0x1F
 rjmp	pkb_Set
